#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include <locale.h>
#include <malloc.h>
#define _CRT_SECURE_NO_WARNINGS
#define Constant1 10
#define BufferInt 100
#define BufferStr 20
#define SQUARE(x) ((x) * (x))

#define CALCULATE_PERIMETR
#define CALCULATE_AREA
#define CALCULATE_BOTH
#pragma once

int sum(int a, int b);
int def(int a, int b);
int del(int a, int b);
int mult(int a, int b);
char* stringMult(char* z, char* v);
int StrToInt(char* s);
char* IntToStr(int n);
int distance(int x1, int x2, int y1, int y2);
int isTriangle(double a, double b, double c);
void triangleProperties(int x1, int y1, int x2, int y2, int x3, int y3);

int sum(int a, int b) {
    int c = a + b;
    return c;
}

int def(int a, int b) {
    int v = a - b;
    return v;
}

int del(int a, int b) {
    int n = a / b;
    return n;
}

int mult(int a, int b) {
    int m = a * b;
    return m;
}

char* stringMult(char* z, char* v) {
    char* third = (char*)malloc(1 + strlen(z) + strlen(v));
    strcpy_s(third, Constant1, z);
    strcat_s(third, Constant1, v);
    return third;
}

int StrToInt(char* s) {
    s[BufferInt];
    return atoi(s);
}

char* IntToStr(int n) {
    char str[BufferStr];
    int i = 0;
    int isNegative = 0;

    if (n < 0) {
        isNegative = 1;
        n = -n;
    }
    //   
    do
    {
        str[i++] = (n % 10) + '0';
        n /= 10;
    } while (n !=0);
    //    
    if (isNegative) {
        str[i++] = '-';
    }
    str[i] = '\0';
    // 
    for (int j = 0, k = i-1 ; j<k; j++, k--)
    {
        char temp = str[j];
        str[j] = str[k];
        str[k] = temp;
    }
    return str;
}


int distance(int x1, int y1, int x2, int y2) {
    double length;

    return length = sqrt(SQUARE(x2-x1) + SQUARE(y2 - y1));
}

int isTriangle(double a, double b, double c) {
    return (a + b > c) && (a + c > b) && (b + c > a);
}

void triangleProperties(int x1, int y1, int x2, int y2, int x3, int y3) {
    double a = distance(x1, y1, x2, y2);
    double b = distance(x2, y2, x3, y3);
    double c = distance(x3, y3, x1, y1);

    if (isTriangle(a, b, c)) {
        double perimeter = a + b + c;
        double s = perimeter / 2;
        double area = sqrt(s * (s - a) * (s - b) * (s - c));

        printf("  \n");
        printf(": %.2f\n", perimeter);
        printf(": %.2f\n", area);
    }
    else {
        printf("   \n");
    }
}

//   
void trianglePropertiesWithDefines(int x1, int y1, int x2, int y2, int x3, int y3) {
    double a = distance(x1, y1, x2, y2);
    double b = distance(x2, y2, x3, y3);
    double c = distance(x3, y3, x1, y1);

    if (isTriangle(a, b, c)) {
        double perimeter = a + b + c;
        double s = perimeter / 2;
        double area = sqrt(s * (s - a) * (s - b) * (s - c));

        printf("  \n");
        #if defined(CALCULATE_PERIMETR) || defined(CALCULATE_BOTH) 
        printf(": %.2f\n", perimeter);
        #endif  
        #if defined(CALCULATE_AREA) || defined(CALCULATE_BOTH)
        printf(": %.2f\n", area);
        #else
        printf(" \n");
        #endif
    }
    else
    {
        printf("   \n");
    }
}